#ifndef INC_GTPANNER_H
#define INC_GTPANNER_H

#include "gtmanager.h"
#include "gtcblist.h"

/************************************************************************\
*
* GtPanner class header.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/

/* Type of callback data */
typedef struct GtPannerCD
{
	long xvalue,yvalue;
	sbool drag;
} GtPannerCD;


/* Internal flags */
#define GTPF_REDUCE		0x01
#define GTPF_REPDRAG	0x02
#define GTPF_PULSE		0x04

class GtKnob;

class GtPanner : public GtManager
{
public:
		/* Standard */
	GtPanner(void);
	sbool Init(char *n,GtManager *p,GtTag *tgs);
	sbool Set(GtTag *tgs);
	void Get(GtTag *tgs);
	char *GetClass(void) { return("GtPanner"); }
	sbool IsSubClassOf(char *cn);
		/* Instance checks */
	sbool IsManager(void) { return(TRUE); }
		/* Child management */
	sbool AddChild(GtWidget *o,ulong pos);
		/* Child requests */
	void MoveSizeReq(GtWidget *obj,word xp,word yp,word xs,word ys);
		/* Layout */
	void Relayout(void);
		/* Values */
	void SetEMask(ulong em);
		/* Callbacks */
	void AddCB(ulong tag,GtCallB cb,GtUDPtr ud);
	void RemCB(ulong tag,GtCallB cb);
		/* Notify */
	void Notify(ulong tag);
protected:
		/* Internal methods */
	void Layout(void);
	sbool Draw(XEvent *xe);
	sbool Mouse(XEvent *xe);
protected:
		/* Instance variables */
	GtCBList chg;
	GtKnob *knob;
	long xstart,ystart,xval,yval;
	ulong xrange,yrange,xrrange,yrrange,xpage,ypage;
	word xknpos,xknsz,yknpos,yknsz,kmxs,kmys;
	ubyte ftype,sflags,ibw,ibdrw,bdrw;
};

extern GtPanner *GtMkPanner(char *n,GtManager *p,GtTag *tgs);
extern GtPanner *GtMkPanner(char *n,GtManager *p,ulong tag,...);

#endif /* INC_GTPANNER_H */
